<template>
	<span :class="{ error: hasError, success: !hasError }">
		<el-autocomplete
			:fetch-suggestions="querySearchAsync"
			v-model="value"
			placeholder="Please input"
			@select="handleSelect"
			@focus="handleFocus"
			@click="handleFocus"
			@change="handleChange"
			@keydown="handleKeyDown"
			@keyup="handleKeyUp"
			:clearable="true"
			:select-when-unmatched="true"
			:trigger-on-focus="props.triggerOnFocus"
			:highlight-first-item="true"
			:disabled="props.disabled"
			value-key="text"
		/>
		<el-icon>
			<check v-show="!hasError" />
			<close v-show="hasError" />
		</el-icon>
	</span>
</template>

<script lang="ts" setup>
import { computed, ref, watch } from 'vue-demi';
import { ElIcon } from "element-plus";
import { TaskEither } from '../../../lib/types';

interface QuerySearch<T> {
	transformItem: (a: T) => Item;
	querySearch: (query: string) => TaskEither<any, T[]>;
}

interface Props {
	querySearch: () => QuerySearch<any>;
	triggerOnFocus?: boolean;
	disabled?: boolean;
	modelValue?: string | null;
}

interface Item {
	value: string;
	text: string;
}

const props = withDefaults(defineProps<Props>(), {
	triggerOnFocus: false,
	disabled: false,
	modelValue: () => null,
});
const value = ref(props.modelValue);
const emit = defineEmits<{
	(e: 'change', value: string | null): void
}>();
const selectedItem = ref<Item | null>(null);
const currentKey = ref<string | null>(null);
let prevValue = props.modelValue;
const hasError = computed(() => !selectedItem.value);
const valueChanged = () => value.value !== prevValue;

watch(() => props.modelValue, (newValue) => {
	if (!newValue) {
		value.value = null;
		changeItem(null);
		console.log('reset value');
	} else {
		console.log('input search', value.value, newValue);
		value.value = newValue;
		prevValue = newValue;
	}
});

async function querySearchAsync(query: string, callback: (arg: any) => void) {
	query = query && query.trim() || '';

	if (selectedItem.value?.text === query) {
		callback([]);
		return;
	}
	selectedItem.value = null;
	const { transformItem, querySearch } = props.querySearch();

	const items = await handleTask(querySearch(query), transformItem);
	callback(items);
}

function handleSelect(item: Item) {
	console.log('handleSelect', item);
	changeItem(item);
}

function handleFocus(e: FocusEvent) {
	const input = <HTMLInputElement>e.target;
	input.setSelectionRange(0, input.value.length);
}

function handleKeyDown(e: KeyboardEvent) {
	currentKey.value = e.key;

	if (valueChanged()) {
		// zmena
		console.log('zmena down', prevValue, value.value);
		changeItem(null);
	}
}

function handleKeyUp() {
	if (valueChanged()) {
		// zmena
		console.log('zmena up', prevValue, value.value);
		changeItem(null);
	}
	currentKey.value = null;
	prevValue = value.value;
}

function handleChange(val: string) {
	console.log('handleChange', val);
	if (!val) {
		console.log('handleChange null', val);
		changeItem(null);
		return;
	}

	if (valueChanged()) {
		console.log('handle cahnge changed');
		changeItem(null);
	}
}

function changeItem(item: Item | null) {
	console.log('change ', item, item?.value);
	const val = item && item.value && item || null;

	selectedItem.value = val;
	emit('change', item?.value || null);
	prevValue = item?.text || null;
}

async function handleTask<T>(task: TaskEither<any, T[]>, transform: (a: T) => Item): Promise<Item[]> {
	const result = await task();
	switch (result._tag) {
		case "Right":
			return result.right.map(transform);
		default:
			return [{ text: 'Network problem...', value: '' }];
	}
}

</script>

<style lang="scss">
.error {
	input {
		border-color: red !important;
	}

	i.el-icon {
		color: red;
	}
}

.success {
	input {
		border-color: green !important;
	}

	i.el-icon {
		color: green;
	}
}
</style>